#version 140

uniform sampler2D readTexture;
uniform sampler2D seedpoints;
uniform float size;
uniform float time;
uniform float offset;

in vec2 vertex;

out vec4 newParticle;

float rand(vec2 seed)
{
	// returns between 0.0 and 1.0
	return fract(sin(dot(seed.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

void main(void)
{
	newParticle = texture(readTexture, vertex);

	//if(newParticle.x>=0.0) newParticle.x -= rand(vertex*123.456)*0.0005;
	//else newParticle.x += rand(vertex*123.456)*0.0005;
	//if(newParticle.y>=0.0) newParticle.y -= rand(vertex*234.567)*0.0005;
	//else newParticle.y += rand(vertex*234.567)*0.0005;

	newParticle.z += rand(vertex*345.678)*0.1;
	newParticle.w += 0.006;

	// reincarnation
	if(newParticle.w > 1.0)
	{
		vec4 tmp = texture(seedpoints, vertex);
		newParticle.x = tmp.x;//rand(vertex*123.456)*0.2;
		newParticle.y = tmp.y;//rand(vertex*234.567)*0.2+sin(time/2.0)/2.0;
		newParticle.z = tmp.z+1.01+offset;//0.0;
		newParticle.w = rand(vertex*456.789);
	}

	gl_PointSize = 1.0;

	gl_Position = vec4(vertex*2.0-vec2(1.0-1.0/size, 1.0-1.0/size), 0.0, 1.0);
}
